%global orig_name i3

Name:           i3-gaps
Version:        4.19.1
Release:        1%{?dist}
Summary:        i3 with more features
License:        BSD
URL:            https://github.com/Airblader/i3
Source0:        https://github.com/Airblader/%{orig_name}/archive/%{version}/%{orig_name}-%{version}.tar.gz
Source1:        %{orig_name}-logo.svg
Patch0:         hexid.patch

BuildRequires:  gcc
BuildRequires:  doxygen
# need at least 0.53 to build the documentation
BuildRequires:  meson >= 0.53
# from meson.build
BuildRequires:  pkg-config >= 0.25
# no pkg-config for libev
BuildRequires:  libev-devel >= 4.0
BuildRequires:  pkgconfig(libstartup-notification-1.0)
BuildRequires:  pkgconfig(xcb) >= 1.1.93
BuildRequires:  pkgconfig(xcb-xkb)
BuildRequires:  pkgconfig(xcb-xinerama)
BuildRequires:  pkgconfig(xcb-randr)
BuildRequires:  pkgconfig(xcb-shape)
BuildRequires:  pkgconfig(xcb-event)
BuildRequires:  pkgconfig(xcb-util)
BuildRequires:  pkgconfig(xcb-cursor)
BuildRequires:  pkgconfig(xcb-keysyms)
BuildRequires:  pkgconfig(xcb-icccm)
BuildRequires:  pkgconfig(xcb-xrm)
BuildRequires:  pkgconfig(xkbcommon) >= 0.4.0
BuildRequires:  pkgconfig(xkbcommon-x11) >= 0.4.0
BuildRequires:  pkgconfig(yajl) >= 2.0.1
BuildRequires:  pkgconfig(libpcre) >= 8.10
BuildRequires:  pkgconfig(cairo) >= 1.14.4
BuildRequires:  pkgconfig(pangocairo) >= 1.30.0
BuildRequires:  pkgconfig(glib-2.0)
BuildRequires:  pkgconfig(gobject-2.0)
# man pages
BuildRequires:  asciidoc >= 8.3.0
BuildRequires:  xmlto >= 0.0.23

# TODO: Testsuites
BuildRequires:  perl(AnyEvent)
BuildRequires:  perl(AnyEvent::Util)
BuildRequires:  perl(AnyEvent::Handle)
BuildRequires:  perl(AnyEvent::I3)
BuildRequires:  perl(ExtUtils::MakeMaker)
#BuildRequires:  perl(strict)
#BuildRequires:  perl(warnings)
#BuildRequires:  perl(Pod::Usage)
#BuildRequires:  perl(Cwd)
#BuildRequires:  perl(File::Temp)
#BuildRequires:  perl(Getopt::Long)
#BuildRequires:  perl(POSIX)
#BuildRequires:  perl(TAP::Harness)
#BuildRequires:  perl(TAP::Parser)
#BuildRequires:  perl(TAP::Parser::Aggregator)
#BuildRequires:  perl(Time::HiRes)
#BuildRequires:  perl(IO::Handle)
#BuildRequires:  perl(AnyEvent::Util)
#BuildRequires:  perl(AnyEvent::Handle)
#BuildRequires:  perl(AnyEvent::I3)
#BuildRequires:  perl(X11::XCB::Connection)
#BuildRequires:  perl(Carp)

BuildRequires:  perl-generators
BuildRequires:  perl(Pod::Simple)
%ifnarch s390 s390x
BuildRequires:  xorg-x11-drv-dummy
%endif

Requires:       perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
%{!?rhel:Recommends:     rxvt-unicode}
Requires:       xorg-x11-fonts-misc
Recommends:     pulseaudio-utils
# for i3-save-tree
Requires:       perl(AnyEvent::I3) >= 0.12

Recommends:     dmenu
Recommends:     i3status
Recommends:     i3lock

Conflicts:      otherproviders(i3)
Provides:       i3 = %{version}


%description
Key features of i3 are correct implementation of XrandR, horizontal and vertical
columns (think of a table) in tiling. Also, special focus is on writing clean,
readable and well documented code. i3 uses xcb for asynchronous communication
with X11, and has several measures to be very fast.

Please be aware that i3 is primarily targeted at advanced users and developers.


%package        doc
Summary:        Documentation for %{name}
BuildArch:      noarch
Requires:       %{name} = %{version}-%{release}


%description    doc
Asciidoc generated documentation for %{name}.


%prep
%autosetup -p1 -n %{orig_name}-%{version}

# Drop /usr/bin/env lines in those which will be installed to %%_bindir.
find . -maxdepth 1 -type f -name "i3*" -exec sed -i -e '1s;^#!/usr/bin/env perl;#!/usr/bin/perl;' {} + -print


%build
%meson -Ddocs=true -Dmans=true
%meson_build

doxygen pseudo-doc.doxygen
mv pseudo-doc/html pseudo-doc/doxygen


%install
%meson_install

mkdir -p %{buildroot}%{_mandir}/man1/
find -name i3\*.1 -exec install -Dpm0644 {} %{buildroot}%{_mandir}/man1/ \;

mkdir -p %{buildroot}%{_datadir}/pixmaps/
install -Dpm0644 %{SOURCE1} \
        %{buildroot}%{_datadir}/pixmaps/


%files
%doc RELEASE-NOTES-%{version}
%license LICENSE
%{_bindir}/%{orig_name}*
%{_includedir}/%{orig_name}/
%dir %{_sysconfdir}/%{orig_name}/
%config(noreplace) %{_sysconfdir}/%{orig_name}/config
%config(noreplace) %{_sysconfdir}/%{orig_name}/config.keycodes
%{_datadir}/xsessions/%{orig_name}.desktop
%{_datadir}/xsessions/%{orig_name}-with-shmlog.desktop
%{_mandir}/man*/%{orig_name}*
%{_datadir}/pixmaps/%{orig_name}-logo.svg
%{_datadir}/applications/%{orig_name}.desktop
%exclude %{_docdir}/%{orig_name}/


%files doc
%license LICENSE
%doc docs/*.{html,png} pseudo-doc/doxygen/


%changelog
* Wed Mar 31 2021 Nikola Forró <nforro@redhat.com> - 4.19.1-1
- New upstream release 4.19.1

* Wed Aug 28 2019 Nikola Forró <nforro@redhat.com> - 4.17-1
- New upstream release 4.17

* Wed Aug 29 2018 Nikola Forró <nforro@redhat.com> - 4.15.0.1-2
- Add hexid match criterion

* Fri Apr 06 2018 Nikola Forró <nforro@redhat.com> - 4.15.0.1-1
- Initial package
